@echo off

set HOME=%~dps0
set HOME=%HOME:~0,-1%

rem quick jump if just one available
set countver=0
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw32DPOpt   set /A countver=countver+1 & set jumpto=w32
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw-w32SPOpt set /A countver=countver+1 & set jumpto=ww32S
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw-w32DPOpt set /A countver=countver+1 & set jumpto=ww32
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw-w64DPOpt set /A countver=countver+1 & set jumpto=ww64
if "%countver%"=="1" goto %jumpto%

rem user options interface
echo Setting up OpenFOAM variables - Choose one option:
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw32DPOpt   echo 1 - mingw32 Double Precision version
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw-w32SPOpt echo 2 - mingw-w32 Single Precision version
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw-w32DPOpt echo 3 - mingw-w32 Double Precision version
if exist %HOME%\OpenFOAM-1.6\lib\linuxmingw-w64DPOpt echo 4 - mingw-w64 Double Precision version
echo.
choice /C:1234 /M "Choose one (any other will use the last one picked):"
IF ERRORLEVEL 4 goto ww64
IF ERRORLEVEL 3 goto ww32
IF ERRORLEVEL 2 goto ww32S
IF ERRORLEVEL 1 goto w32

:ww64
set WM_COMPILER=mingw-w64
echo "Setting environment for mingw-w64 Double Precision"
goto cont

:ww32
set WM_COMPILER=mingw-w32
echo "Setting environment for mingw-w32 Double Precision"
goto cont

:ww32S
set WM_COMPILER=mingw-w32S
echo "Setting environment for mingw-w32 Single Precision"
goto cont

:w32
set WM_COMPILER=mingw32
echo "Setting environment for mingw32 Double Precision"
goto cont

:cont
set jumpto=
set countver=

rem BEGGINING of User Modifiables --------------------------------------

rem PICK ONE form these 3: mingw32, mingw-w32, mingw-w32S (Single Precision), mingw-w64
rem set WM_COMPILER=mingw32
rem set WM_COMPILER=mingw-w32
rem set WM_COMPILER=mingw-w32S
rem set WM_COMPILER=mingw-w64

rem PICK ONE: dummy or MPICH
rem set WM_MPLIB=dummy
set WM_MPLIB=MPICH


rem END OF USER MODIFIABLES ---------------------------------------------

set WM_PRECISION_OPTION=DP
IF "%WM_COMPILER%"=="mingw-w32S" set WM_PRECISION_OPTION=SP
IF "%WM_COMPILER%"=="mingw-w32S" set WM_COMPILER=mingw-w32

set USER=ofuser
set USERNAME=ofuser
set WM_PROJECT=OpenFOAM
set WM_PROJECT_VERSION=1.6
set FOAM_INST_DIR=%HOME%
rem set FOAM_INST_DIR=%HOME%\%WM_PROJECT%
set WM_PROJECT_INST_DIR=%FOAM_INST_DIR%
set WM_PROJECT_DIR=%FOAM_INST_DIR%\%WM_PROJECT%-%WM_PROJECT_VERSION%
set WM_PROJECT_USER_DIR=%HOME%\%USER%-%WM_PROJECT_VERSION%
set WM_THIRD_PARTY_DIR=%WM_PROJECT_INST_DIR%\ThirdParty-%WM_PROJECT_VERSION%
set WM_OS=MSwindows

IF "%WM_COMPILER%"=="mingw32" set WM_ARCH_OPTION=32
IF "%WM_COMPILER%"=="mingw-w32" set WM_ARCH_OPTION=32
IF "%WM_COMPILER%"=="mingw-w64" set WM_ARCH_OPTION=64

set WM_ARCH=linux
set WM_COMPILE_OPTION=Opt
set WM_JAVAC_OPTION=Opt

set FOAM_SIGFPE=""
set WM_COMPILER_ARCH=""
set WM_COMPILER_LIB_ARCH=""
set WM_CC=x86_64-pc-mingw32-gcc
set WM_CXX=x86_64-pc-mingw32-g++
set FOAM_JOB_DIR=%FOAM_INST_DIR%\jobControl
set WM_DIR=%WM_PROJECT_DIR%\wmake
set WM_LINK_LANGUAGE=c++
set WM_OPTIONS=%WM_ARCH%%WM_COMPILER%%WM_PRECISION_OPTION%%WM_COMPILE_OPTION%

set FOAM_SRC=%WM_PROJECT_DIR%\src
set FOAM_LIB=%WM_PROJECT_DIR%\lib
set FOAM_LIBBIN=%FOAM_LIB%\%WM_OPTIONS%
set FOAM_APP=%WM_PROJECT_DIR%\applications
set FOAM_APPBIN=%WM_PROJECT_DIR%\applications\bin\%WM_OPTIONS%

set FOAM_TUTORIALS=%WM_PROJECT_DIR%\tutorials
set FOAM_UTILITIES=%FOAM_APP%\utilities
set FOAM_SOLVERS=%FOAM_APP%\solvers
set FOAM_USER_LIBBIN=%WM_PROJECT_USER_DIR%\lib\%WM_OPTIONS%
set FOAM_USER_APPBIN=%WM_PROJECT_USER_DIR%\applications\bin\%WM_OPTIONS%
set FOAM_RUN=%WM_PROJECT_USER_DIR%\run

IF "%WM_MPLIB%"=="dummy" set mpi_version=dummy
IF "%WM_MPLIB%"=="MPICH" set mpi_version=mpich2-1.1.1p1

set MPI_HOME=%WM_THIRD_PARTY_DIR%\%mpi_version%
set MPI_ARCH_PATH=%MPI_HOME%\platforms\%WM_OPTIONS%

set MPICH_ROOT=%MPI_ARCH_PATH%
set FOAM_MPI_LIBBIN=%FOAM_LIBBIN%\%mpi_version%
set MPI_BUFFER_SIZE=20000000

set ParaView_VERSION=3.6.1

set ParaView_INST_DIR=%WM_THIRD_PARTY_DIR%\paraview-%ParaView_VERSION%
set ParaView_DIR=%ParaView_INST_DIR%\platforms\%WM_ARCH%%WM_COMPILER%

set PATH=%PATH%;%MPI_ARCH_PATH%\lib;%MPI_ARCH_PATH%\bin;%FOAM_MPI_LIBBIN%;%FOAM_JOB_DIR%;%WM_PROJECT_USER_DIR%\lib\%WM_OPTIONS%;%WM_PROJECT_USER_DIR%\applications\bin\%WM_OPTIONS%;%FOAM_APPBIN%;%FOAM_LIBBIN%;%WM_DIR%;%WM_PROJECT_DIR%\bin;%ParaView_DIR%\bin

%1 %2 %3 %4 %5 %6 %7 %8 %9
